%define lbd_builddir /home/%{name}

Summary:	Lbd is a process that rebuilds distributions
Name:		lbd
Version:	0.25
Release:	%mkrel 11
License:	GPL
Group:		Development/Other
URL:		http://qa.mandriva.com/twiki/bin/view/Main/LbD
Source0:	http://eijk.homelinux.org/build/bin/lbd.sh.bz2
Source1:	http://eijk.homelinux.org/build/bin/lbd_mkchroot.sh.bz2
Source2:	http://eijk.homelinux.org/build/bin/lbd_mksrc.sh.bz2
Source10:	http://eijk.homelinux.org/build/bin/lbd.conf.bz2
Requires:	rpmlint
Requires:	sudo
Requires:	urpmdiff
#Requires:	smart or urpmi
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Lbd is a process that rebuilds distributions

This package contains the lbd scripts

%package -n	%{name}-homedir
Summary:	??
Group:          Development/Other
Requires:	%{name} == %{version}-%{release}

%description -n %{name}-homedir
Lbd is a process that rebuilds distributions

This package contains the files for the lbd user

%prep

%setup -q -c -T

bzcat %{SOURCE0} > lbd.sh
bzcat %{SOURCE1} > lbd_mkchroot.sh
bzcat %{SOURCE2} > lbd_mksrc.sh
bzcat %{SOURCE10} > lbd.conf

%build

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# Main
install -d %{buildroot}%{_bindir}
install -m0755 lbd.sh %{buildroot}%{_bindir} 
install -m0755 lbd_mkchroot.sh %{buildroot}%{_bindir} 
install -m0755 lbd_mksrc.sh %{buildroot}%{_bindir} 

# Homedir
install -d %{buildroot}%{lbd_builddir}
install -d %{buildroot}%{lbd_builddir}/build/NOSRC
install -d %{buildroot}%{lbd_builddir}/build/log
install -d %{buildroot}%{lbd_builddir}/build/media
install -d %{buildroot}%{lbd_builddir}/build/run
install -m0644 lbd.conf %{buildroot}%{lbd_builddir}/lbd.conf

%pre
# add build group
if getent group build >/dev/null 2>&1 ; then : ; else \
	/usr/sbin/groupadd build > /dev/null 2>&1 || exit 1 ; fi

# add lbd group and user
if getent passwd %{name} >/dev/null 2>&1 ; then : ; else \
	%{_sbindir}/useradd \
	-c "Little Build Daemon" \
	-d %{lbd_builddir} \
	-G build \
	-s /bin/bash \
	%{name} 2> /dev/null || exit 1 ; fi

%post
/bin/chmod a+w /etc/sudoers
grep -q '%{name}' /etc/sudoers || \
echo "%{name} ALL=(root) NOPASSWD:%{_sbindir}/chroot,NOPASSWD:/bin/rpm,NOPASSWD:%{_sbindir}/urpmi,NOPASSWD:%{_sbindir}/urpmi.update,NOPASSWD:/bin/mount,NOPASSWD:/bin/umount" >> /etc/sudoers;
/bin/chmod 0440 /etc/sudoers

%postun
if [ "$1" = "0" ]; then
# remove sudoers entry
	/bin/chmod a+w /etc/sudoers
	grep -q '%{name}' /etc/sudoers && \
		perl -ni -e 'print unless m!^%{name}.*!' /etc/sudoers;
		/bin/chmod 0440 /etc/sudoers
	if getent passwd %{name} >/dev/null 2>&1 ; then userdel %{name} ; fi
	if getent group build >/dev/null 2>&1 ; then groupdel build ; fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/lbd.sh
%attr(0755,root,root) %{_bindir}/lbd_mkchroot.sh
%attr(0755,root,root) %{_bindir}/lbd_mksrc.sh

%files -n %{name}-homedir
%defattr(-,%{name},%{name})
%attr(0644,%{name},%{name}) %config(noreplace) %{lbd_builddir}/lbd.conf
%attr(0755,%{name},%{name}) %dir %{lbd_builddir}
%attr(0755,%{name},%{name}) %dir %{lbd_builddir}/build
%attr(0700,%{name},%{name}) %dir %{lbd_builddir}/build/NOSRC
%attr(0755,%{name},%{name}) %dir %{lbd_builddir}/build/log
%attr(0755,%{name},%{name}) %dir %{lbd_builddir}/build/media
%attr(2775,%{name},build) %dir %{lbd_builddir}/build/run

%changelog
* Wed Sep 06 2006 Stefan van der Eijk <stefan@mandriva.org> 0.25-11
- workaround for broken rpm --root implementation
- move searching lockfile from ${LBD}/${P_ARCH}/searching
  to ${BUILDOUTPUT}/searching
- change sleep value from 5 to 1

* Sat Jul 15 2006 Stefan van der Eijk <stefan@eijk.nu> 0.25-10
- use --strict-arch with urpmi (slower, but better)

* Thu Jul 13 2006 Stefan van der Eijk <stefan@eijk.nu> 0.25-9
 - find_new(): add -maxdepth to find in ${RPM_SRC}

* Wed Jul 12 2006 Stefan van der Eijk <stefan@eijk.nu> 0.25-8
  - add extra step: dependency. Build order is now:
    rebuild, new, dependency, old
    - added find_dependency()
    - removed finding the dependency rebuilds from find_old()
  - Don't copy the buildoutput to a seperate directory when
    a segfault / internal compiler error takes place.
    Adding a comment to the logfile is sufficient.
  - reworked BuildRequires removal
  - removed confusing comment from update_media()

* Sun Jun 11 2006 Stefan van der Eijk <stefan@eijk.nu> 0.25-7mdv2007.0
- build:
  - BUILD_RESULT is unknow then there must be a problem
- check_config:
  - add checking global variables
  - when an error is found, remove the runfile
- cleanup:
  - make simpler
- main:
  - make configuration file configurable (${config_file})
- add lbd_mksrc.sh

* Wed Jun 07 2006 Stefan van der Eijk <stefan@eijk.nu> 0.25-6mdv2007.0
- improvements to make the lbd homedir share-able over multiple machines
- check for "no package named" --> indication that something is wrong 
  with the chroot
- rewrote BuildRequires removal
- turn on verbose logging with removal of BuildRequires (for now)

* Mon Jun 05 2006 Stefan van der Eijk <oeriksson@mandriva.com> 0.25-5mdv2007.0
- add NOSRC dir
- new version of lbd script
- seperate package for lbd homedir

* Sun Jun 04 2006 Oden Eriksson <oeriksson@mandriva.com> 0.25-4mdv2007.0
- fix the group and user add
- provide some directories

* Sat Jun 03 2006 Oden Eriksson <oeriksson@mandriva.com> 0.25-3mdv2007.0
- added newer versions of the scripts
- add the lbd user
- add needed sudo entries in %%post

* Sun Aug 07 2005 Stefan van der Eijk <stefan@eijk.nu> 0.25-2mdk
- renamed to lbd
- latest version from sf.net CVS

* Wed Jul 21 2004 Stefan van der Eijk <stefan@eijk.nu> 0.25-1mdk
- 0.25

* Sun Jul 18 2004 Stefan van der Eijk <stefan@eijk.nu> 0.24-1mdk
- initial package
